...
Text file
src/k8s.io/kubernetes/hack/verify-conformance-requirements.sh
1#!/usr/bin/env bash
2
3# Copyright 2019 The Kubernetes Authors.
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# This script checks conformance tests follow the requirements as
18# https://git.k8s.io/community/contributors/devel/sig-architecture/conformance-tests.md#conformance-test-requirements
19# Usage: `hack/verify-conformance-requirements.sh`.
20
21set -o errexit
22set -o nounset
23set -o pipefail
24
25KUBE_ROOT=$(dirname "${BASH_SOURCE[0]}")/..
26source "${KUBE_ROOT}/hack/lib/init.sh"
27source "${KUBE_ROOT}/hack/lib/util.sh"
28
29kube::golang::setup_env
30
31cd "${KUBE_ROOT}"
32
33errors=()
34# Check conformance tests follow the requirements as https://git.k8s.io/community/contributors/devel/sig-architecture/conformance-tests.md#conformance-test-requirements
35if ! failedLint=$(GOPROXY=off go run hack/conformance/check_conformance_test_requirements.go "${KUBE_ROOT}"/test/e2e/)
36then
37 errors+=( "${failedLint}" )
38fi
39
40# Check to be sure all the packages that should pass lint are.
41if [ ${#errors[@]} -eq 0 ]; then
42 echo 'Congratulations! All e2e test source files have been linted for conformance requirements.'
43else
44 {
45 echo "Errors from lint:"
46 for err in "${errors[@]}"; do
47 echo "$err"
48 done
49 echo
50 echo 'Please review the above warnings.'
51 echo
52 } >&2
53 exit 1
54fi
55
View as plain text